//+------------------------------------------------------------------+
//|                                           .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 Red

extern int       N=20; //   
//---- buffers
double ExtMapBuffer1[],ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(); 
   int limit; 
   double chastnoe[],ima[],st_otkl[],kvadr[],vol_proc[],IMA[]; 
//---- 
   if (counted_bars==0) limit=Bars-N; 
   if (counted_bars>=0) limit=Bars-counted_bars; 
   limit--; 
   for (int i=limit;i>=0;i--) 
      { 
      chastnoe[i]=NormalizeDouble (MathLog(Close[i]/Close[i+1]),6);
      ima[i]=NormalizeDouble (iMAOnArray(chastnoe[i],0,N,0,0,1),6);
       kvadr[i]= MathPow((ima[i]-chastnoe[i]),2);
       st_otkl[i]=MathSqrt(NormalizeDouble (iMAOnArray(kvadr[i],0,N,0,0,1),6));
       vol_proc[i]=st_otkl[i]*15.8745;
       IMA[i]=iMA(NULL,0,N,0,0,PRICE_MEDIAN,i);
      ExtMapBuffer1[i]=NormalizeDouble (IMA[i]+ (IMA[i]*vol_proc[i]),Digits);
      ExtMapBuffer2[i]=NormalizeDouble (IMA[i] - (IMA[i]*vol_proc[i]),Digits);
      } 
//---- 

   return(0);
  }
//+------------------------------------------------------------------+

